<?php
// Update Viessmann Parameter Rest API
// Author: Pascal TRANCHANT Version 1.4 
// Run ViessmannU.php GT=Gateway CT=Controler DG=DatapointGroup HC=Heating-Circuit US=UserID PW=Password TP=Type VL=Value
//	GT contoller could get at https://support.viessmann.io/#/login, Gateways->Find gateway->Search, Details->ID 
//	CT contoller could get at https://support.viessmann.io/#/login Contollers, ID
//	DG DatapointGroup could get at https://api.viessmann.io/estrella/rest/v2.0/gateways/{gatewayID}/controllers/{ContollerID}/datapoints 
//	HC Heating Circuit could get at https://api.viessmann.io/estrella/rest/v2.0/gateways/{gatewayID}/controllers/{ContollerID}/datapoints   
//	DP DatapointId could get at https://api.viessmann.io/estrella/rest/v2.0/gateways/{gatewayID}/controllers/{ContollerID}/datapoints 
//	US Wiessmann Vitoconnect userID normally email address
//	PW Wiessmann Vitoconnect pawwsord
//	TP update type
//		Water				Update Water Temperature
//		Eau					Mise a jour de la consigne de temperature Eau  
//		Room				Update Room Temperature
//		Ambiante			Mise a jour de la consigne de temperature Ambiante
//		Reduced				Update Eco Temperature
//		Réduite				Mise a jour de la consigne de temperature Eco
//		ConsComf			Update Comfort Temperature
//		CondConf			Mise a jour de la consigne de temperature Confort
//		Mode				Set mode Boiler
//		Mode				defini le Mode de la chaudiere
//		Eco					Set Eco mode On/Off
//		Eco					Activer ou désactiver le mode Eco
//		Comfort				Set Comfort mode On/Off
//		Confort				Activer ou désactiver le mode Confort
//		Date				Synchronize Date and time
//		Date				Syncrhonisation de la Date et heure
//		Pente				Pente réglage de la courbe de chauffe
//		Slope				Slope Heating Curve Adjustment 
//		Para				Parallele réglage de la courbe de chauffe
//		Shift				Shift Heating Curve Adjustment
//	VL update value
//		Water,Eau			Temperature between 10 and 95
//		Room,Ambiante		Temperature between 3 and 37
//		Reduced,Réduit		Temperature between 3 and 37
//		ConsConf,ConsComf	Temperature between 4 and 37  
//		Mode				0:stop, 1:Water only, 2:heating and water, 3:Away, 4:force Heating water  
//		Eco					Enable=On Disbale=Off
//		Comfort,Confort		Disbale=Off, Enable=On
//		Date				Synchronization=Sync
//		Pente,Slope			Slope setting between 0.20 and 3.50
//		Para,Shift			Shift setting between -13.00 and 40.00

    
if (isset($argv)) {
     foreach ($argv as $arg) {
         $argList = explode('=', $arg);
         if (isset($argList[0]) && isset($argList[1])) {
             $_GET[$argList[0]] = $argList[1];
         }
     }
}


$gateway = $_GET['GT'];
$controller = $_GET['CT'];
$dataPGroup = $_GET['DG'];
$heatCircuit = $_GET['HC'];
$dataPId = '';
$username = $_GET['US'];
$password = $_GET['PW'];
$type = $_GET['TP'];
$value = $_GET['VL'];
$data_string = '';


if ($argc < 9 || $argc > 10 || $gateway =="" || $controller =="" || $dataPGroup =="" || $heatCircuit =="" || $username =="" || $password =="" || $type =="" || $value =="") {
  		exit( "Usage: ViessmannU.php GT=Gateway CT=Controler DG=DatapointGroup HC=Heating-Circuit [DP=DatapointId] US=UserID PW=Password TP=Type VL=Value\n" );
	}
	else if ($argc == 10) {
    		$dataPId = $_GET['DP'];	
      		if ($dataPId =="") {
	  			exit( "Usage: ViessmannU.php GT=Gateway CT=Controler DG=DatapointGroup HC=Heating-Circuit [DP=DatapointId] US=UserID PW=Password TP=Type VL=Value\n" );
		    }
         }   

function init_Viess()
	{
	$data_string = '';
	$data_string .= '    {'."\r\n";
	$data_string .= '      "metadata": {'."\r\n";
  	return $data_string;
	}

function rest_Viess($url,$ch,$username,$password,$data_string)
	{
	$data_string .= '    }'."\r\n";

  	$ch = curl_init($url);                                                                      
	curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");                                                                     
	curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "PUT");
	curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);                                                                  
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);                                                                      
	curl_setopt($ch, CURLOPT_USERPWD, "$username:$password");
	curl_setopt($ch, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
	curl_setopt($ch, CURLOPT_HTTPHEADER, array(                                                                          
	    'Content-Type: application/json',                                                                                
	    'Content-Length: ' . strlen($data_string))                                                                       
	);


//	echo $url."\n".$data_string."\n";
	$output = curl_exec($ch);

/* 	if (!curl_errno($ch)) {
  	$info = curl_getinfo($ch);
  	echo 'Took ', $info['total_time'], ' seconds to send a request to ', $info['url'], "\n";
	} */
	echo curl_errno($ch);
  
}


$ch = curl_init();	


switch ($type) {
   	 case "Water":
     case "Eau":
		if ($value >= 10 && $value <= 95) {
	    	$data_string = init_Viess();
            if ($dataPId == '') $dataPId = '51';
	    	$url = "https://api.viessmann.io/estrella/rest/v2.0/gateways/".$gateway."/controllers/".$controller."/datapoints/".$dataPId;
	    	$data_string .= '        "minimalValue": "10.00",'."\r\n";
	    	$data_string .= '        "maximalValue": "95.00",'."\r\n";
	    	$data_string .= '        "defaultValue": "50",'."\r	\n";
	    	$data_string .= '        "unitDesignation": "ecnUnit.Grad C",'."\r\n";
	    	$data_string .= '        "datapointGroup": "'.$dataPGroup.'",'."\r\n";
	    	$data_string .= '        "heatingCircuitId": "'.$heatCircuit.'",'."\r\n";
	    	$data_string .= '        "datapointId": "'.$dataPId.'",'."\r\n";
	    	$data_string .= '        "datapointType": "Integer",'."\r\n";
	    	$data_string .= '        "datapointName": "konf_ww_solltemp_rw",'."\r\n";
	    	$data_string .= '        "isWritable": true,'."\r\n";
	    	$data_string .= '        "isReadable": true,'."\r\n";
	    	$data_string .= '        "datapointTypeValue": 0'."\r\n";
	    	$data_string .= '      },'."\r\n";
	    	$data_string .= '      "value": "'.$value.'",'."\r\n";
	    	$data_string .= '      "dataType": 2,'."\r\n";
	    	$data_string .= '      "datapointType": 0,'."\r\n";
	    	$data_string .= '      "datapointStatus": 0'."\r\n";
	    	rest_Viess($url,$ch,$username,$password,$data_string);
		}
        break;
   	 case "Room":
   	 case "Ambiante":
		if ($value >= 3 && $value <= 37) {
	    	$data_string = init_Viess();
            if ($dataPId == '') $dataPId = '82';
	    	$url = "https://api.viessmann.io/estrella/rest/v2.0/gateways/".$gateway."/controllers/".$controller."/datapoints/".$dataPId;
	    	$data_string .= '      "minimalValue": "3.00",'."\r\n";
	    	$data_string .= '      "maximalValue": "37.00",'."\r\n";
	    	$data_string .= '      "defaultValue": "20",'."\r\n";
	    	$data_string .= '      "unitDesignation": "ecnUnit.Grad C",'."\r\n";
	    	$data_string .= '      "datapointGroup": "'.$dataPGroup.'",'."\r\n";
	    	$data_string .= '      "heatingCircuitId": "'.$heatCircuit.'",'."\r\n";
	    	$data_string .= '      "datapointId": "'.$dataPId.'",'."\r\n";
	    	$data_string .= '      "datapointType": "Integer",'."\r\n";
	    	$data_string .= '      "datapointName": "konf_raumsolltemp_rw",'."\r\n";
	    	$data_string .= '      "isWritable": true,'."\r\n";
	    	$data_string .= '      "isReadable": true,'."\r\n";
	    	$data_string .= '      "datapointTypeValue": 0'."\r\n";
	    	$data_string .= '      },'."\r\n";
	    	$data_string .= '      "value": "'.$value.'",'."\r\n";
	    	$data_string .= '      "dataType": 2,'."\r\n";
	    	$data_string .= '      "datapointType": 0,'."\r\n";
	    	$data_string .= '      "datapointStatus": 0'."\r\n";
	    	rest_Viess($url,$ch,$username,$password,$data_string);
		}
        break;
   	 case "Reduced":
   	 case "Réduite":
		if ($value >= 3 && $value <= 37) {
	    	$data_string = init_Viess();
	    	if ($dataPId == '') $dataPId = '85';
	    	$url = "https://api.viessmann.io/estrella/rest/v2.0/gateways/".$gateway."/controllers/".$controller."/datapoints/".$dataPId;
	    	$data_string .= '      "minimalValue": "3.00",'."\r\n";
	    	$data_string .= '      "maximalValue": "37.00",'."\r\n";
	    	$data_string .= '      "defaultValue": "3",'."\r\n";
	    	$data_string .= '      "unitDesignation": "ecnUnit.Grad C",'."\r\n";
	    	$data_string .= '      "datapointGroup": "'.$dataPGroup.'",'."\r\n";
	    	$data_string .= '      "heatingCircuitId": "'.$heatCircuit.'",'."\r\n";
	    	$data_string .= '      "datapointId": "'.$dataPId.'",'."\r\n";
	    	$data_string .= '      "datapointType": "Integer",'."\r\n";
	    	$data_string .= '      "datapointName": "konf_raumsolltemp_reduziert_rw",'."\r\n";
	    	$data_string .= '      "isWritable": true,'."\r\n";
	    	$data_string .= '      "isReadable": true,'."\r\n";
	    	$data_string .= '      "datapointTypeValue": 0'."\r\n";
	    	$data_string .= '      },'."\r\n";
	    	$data_string .= '      "value": "'.$value.'",'."\r\n";
	    	$data_string .= '      "dataType": 2,'."\r\n";
	    	$data_string .= '      "datapointType": 0,'."\r\n";
	    	$data_string .= '      "datapointStatus": 0'."\r\n";
	    	rest_Viess($url,$ch,$username,$password,$data_string);
		}
        break;
   	 case "ConsConf":
   	 case "ConsComf":
	    if ($value >= 4 && $value <= 37) {
           	$data_string = init_Viess();
	    	if ($dataPId == '') $dataPId = '79';
	    	$url = "https://api.viessmann.io/estrella/rest/v2.0/gateways/".$gateway."/controllers/".$controller."/datapoints/".$dataPId;
        	$data_string .= '        "minimalValue": "4.00",'."\r\n";
          	$data_string .= '        "maximalValue": "37.00",'."\r\n";
        	$data_string .= '        "defaultValue": "20",'."\r\n";
        	$data_string .= '        "unitDesignation": "ecnUnit.Grad C",'."\r\n";
	    	$data_string .= '        "datapointGroup": "'.$dataPGroup.'",'."\r\n";
	    	$data_string .= '        "heatingCircuitId": "'.$heatCircuit.'",'."\r\n";
	    	$data_string .= '        "datapointId": "'.$dataPId.'",'."\r\n";
        	$data_string .= '        "datapointType": "Integer",'."\r\n";
        	$data_string .= '        "datapointName": "konf_partysolltemp_rw",'."\r\n";
        	$data_string .= '        "isWritable": true,'."\r\n";
        	$data_string .= '        "isReadable": true,'."\r\n";
        	$data_string .= '        "datapointTypeValue": 0'."\r\n";
      		$data_string .= '      },'."\r\n";
      		$data_string .= '        "value": "'.$value.'",'."\r\n";
      		$data_string .= '        "dataType": 2,'."\r\n";
      		$data_string .= '        "datapointType": 0,'."\r\n";
      		$data_string .= '        "datapointStatus": 0'."\r\n";
	    	rest_Viess($url,$ch,$username,$password,$data_string);
		}
        break;
  	case "Mode":
    	if ($value >= 0 && $value <= 4) {
    		$data_string = init_Viess();
	    	if ($dataPId == '') $dataPId = '92';
	    	$url = "https://api.viessmann.io/estrella/rest/v2.0/gateways/".$gateway."/controllers/".$controller."/datapoints/".$dataPId;
          	$data_string .= '      "values": {'."\r\n";
	    	$data_string .= '      "0": "Abschalt",'."\r\n";
	    	$data_string .= '      "1": "Nur WW",'."\r\n";
	    	$data_string .= '      "2": "Heizen + WW",'."\r\n";
	    	$data_string .= '      "3": "Dauernd Reduziert",'."\r\n";
	    	$data_string .= '      "4": "Dauernd Normal"'."\r\n";
	    	$data_string .= '      },'."\r\n";
	    	$data_string .= '      "datapointGroup": "'.$dataPGroup.'",'."\r\n";
	    	$data_string .= '      "heatingCircuitId": "'.$heatCircuit.'",'."\r\n";
	    	$data_string .= '      "datapointId": "'.$dataPId.'",'."\r\n";
	    	$data_string .= '      "datapointType": "ENUM",'."\r\n";
	    	$data_string .= '      "datapointName": "konf_betriebsart_rw",'."\r\n";
	    	$data_string .= '      "isWritable": true,'."\r\n";
	    	$data_string .= '      "isReadable": true,'."\r\n";
	    	$data_string .= '      "datapointTypeValue": 0'."\r\n";
	    	$data_string .= '      },'."\r\n";
	    	$data_string .= '      "value": "'.$value.'",'."\r\n";
	    	$data_string .= '      "dataType": 2,'."\r\n";
	    	$data_string .= '      "datapointType": 1,'."\r\n";
	    	$data_string .= '      "datapointStatus": 0	'."\r\n";
            rest_Viess($url,$ch,$username,$password,$data_string);
		}
        break;
  	 case "Eco":
    	$data_string = init_Viess();
    	if ($dataPId == '') $dataPId = '7852';
    	$url = "https://api.viessmann.io/estrella/rest/v2.0/gateways/".$gateway."/controllers/".$controller."/datapoints/".$dataPId;
		$data_string .= '        "values": {'."\r\n";
		$data_string .= '        "0": "Aus",'."\r\n";
		$data_string .= '        "1": "Ein"'."\r\n";
		$data_string .= '      },'."\r\n";
	    $data_string .= '        "datapointGroup": "'.$dataPGroup.'",'."\r\n";
	    $data_string .= '        "heatingCircuitId": "'.$heatCircuit.'",'."\r\n";
	    $data_string .= '        "datapointId": "'.$dataPId.'",'."\r\n";
		$data_string .= '        "datapointType": "ENUM",'."\r\n";
		$data_string .= '        "datapointName": "konf_sparbetrieb_rw",'."\r\n";
		$data_string .= '        "isWritable": true,'."\r\n";
		$data_string .= '        "isReadable": true,'."\r\n";
		$data_string .= '        "datapointTypeValue": 0'."\r\n";
		$data_string .= '      },'."\r\n";
		if ($value == "On") 
    		$data_string .= '        "value": "1",'."\r\n";
    	else
    		$data_string .= '        "value": "0",'."\r\n";          
		$data_string .= '        "dataType": 2,'."\r\n";
		$data_string .= '        "datapointType": 1,'."\r\n";
		$data_string .= '        "datapointStatus": 0'."\r\n";
    	rest_Viess($url,$ch,$username,$password,$data_string);    
        break;
   	 case "Comfort":
   	 case "Confort":
        $data_string = init_Viess();
    	if ($dataPId == '') $dataPId = '7855';
    	$url = "https://api.viessmann.io/estrella/rest/v2.0/gateways/".$gateway."/controllers/".$controller."/datapoints/".$dataPId;
	    $data_string .= '        "values": {'."\r\n";
		$data_string .= '          "0": "Aus",'."\r\n";
		$data_string .= '          "1": "Ein"'."\r\n";
		$data_string .= '        },'."\r\n";
	    $data_string .= '        "datapointGroup": "'.$dataPGroup.'",'."\r\n";
	    $data_string .= '        "heatingCircuitId": "'.$heatCircuit.'",'."\r\n";
	    $data_string .= '        "datapointId": "'.$dataPId.'",'."\r\n";
		$data_string .= '        "datapointType": "ENUM",'."\r\n";
		$data_string .= '        "datapointName": "konf_partybetrieb_rw",'."\r\n";
		$data_string .= '        "isWritable": true,'."\r\n";
		$data_string .= '        "isReadable": true,'."\r\n";
		$data_string .= '        "datapointTypeValue": 0'."\r\n";
		$data_string .= '      },'."\r\n";
		if ($value == "Off") 
    		$data_string .= '        "value": "0",'."\r\n";
    	else
    		$data_string .= '        "value": "1",'."\r\n";          
		$data_string .= '        "dataType": 2,'."\r\n";
		$data_string .= '        "datapointType": 1,'."\r\n";
		$data_string .= '        "datapointStatus": 0'."\r\n";
    	rest_Viess($url,$ch,$username,$password,$data_string);    
    	break;
   	 case "Date":
        $data_string = init_Viess();
    	if ($dataPId == '') $dataPId = '5385';
    	$url = "https://api.viessmann.io/estrella/rest/v2.0/gateways/".$gateway."/controllers/".$controller."/datapoints/".$dataPId;    
		$data_string .= '        "minimalValue": "0.00",'."\r\n";
		$data_string .= '        "maximalValue": "0.00",'."\r\n";
		$data_string .= '        "defaultValue": "",'."\r\n";
		$data_string .= '        "unitDesignation": "",'."\r\n";
		$data_string .= '        "datapointGroup": "DEFAULT-GROUP",'."\r\n";
    	$data_string .= '        "heatingCircuitId": "'.$heatCircuit.'",'."\r\n";
	    $data_string .= '        "datapointId": "'.$dataPId.'",'."\r\n";
		$data_string .= '        "datapointType": "Date",'."\r\n";
		$data_string .= '        "datapointName": "konf_uhrzeit_rw",'."\r\n";
		$data_string .= '        "isWritable": true,'."\r\n";
		$data_string .= '        "isReadable": true,'."\r\n";
		$data_string .= '        "datapointTypeValue": 0'."\r\n";
		$data_string .= '        },'."\r\n";
		$data_string .= '        "value": "'.date('n/j/Y g:i:s A').'",'."\r\n";
		$data_string .= '        "dataType": 4,'."\r\n";
		$data_string .= '        "datapointType": 0,'."\r\n";
		$data_string .= '        "datapointStatus": 0'."\r\n";
    	rest_Viess($url,$ch,$username,$password,$data_string);    
    	break;
   	 case "Slope":
   	 case "Pente":    
        $data_string = init_Viess();
    	if ($dataPId == '') $dataPId = '2869';
    	$url = "https://api.viessmann.io/estrella/rest/v2.0/gateways/".$gateway."/controllers/".$controller."/datapoints/".$dataPId;    
    	$data_string .= '        "minimalValue": "0.20",'."\r\n";
    	$data_string .= '        "maximalValue": "3.50",'."\r\n";
    	$data_string .= '        "defaultValue": "1,4",'."\r\n";
    	$data_string .= '        "unitDesignation": "",'."\r\n";
    	$data_string .= '        "datapointGroup": "HC1",'."\r\n";
    	$data_string .= '        "heatingCircuitId": "'.$heatCircuit.'",'."\r\n";
	    $data_string .= '        "datapointId": "'.$dataPId.'",'."\r\n";
    	$data_string .= '        "datapointType": "Double",'."\r\n";
    	$data_string .= '        "datapointName": "konf_neigung_rw",'."\r\n";
    	$data_string .= '        "isWritable": true,'."\r\n";
    	$data_string .= '        "isReadable": true,'."\r\n";
    	$data_string .= '        "datapointTypeValue": 0'."\r\n";
    	$data_string .= '        },'."\r\n";
    	$data_string .= '        "value": "'.$value.'",'."\r\n";
    	$data_string .= '        "dataType": 3,'."\r\n";
    	$data_string .= '        "datapointType": 0,'."\r\n";
    	$data_string .= '        "datapointStatus": 0'."\r\n";
    	rest_Viess($url,$ch,$username,$password,$data_string);    
    	break;
   	 case "Shift":
   	 case "Para":    
        $data_string = init_Viess();
    	if ($dataPId == '') $dataPId = '2875';
    	$url = "https://api.viessmann.io/estrella/rest/v2.0/gateways/".$gateway."/controllers/".$controller."/datapoints/".$dataPId;    
    	$data_string .= '        "minimalValue": "-13.00",'."\r\n";
    	$data_string .= '        "maximalValue": "40.00",'."\r\n";
    	$data_string .= '        "defaultValue": "0",'."\r\n";
    	$data_string .= '        "unitDesignation": "ecnUnit.K",'."\r\n";
    	$data_string .= '        "datapointGroup": "HC1",'."\r\n";
        $data_string .= '        "heatingCircuitId": "'.$heatCircuit.'",'."\r\n";
	    $data_string .= '        "datapointId": "'.$dataPId.'",'."\r\n";
    	$data_string .= '        "datapointType": "Double",'."\r\n";
    	$data_string .= '        "datapointName": "konf_niveau_rw",'."\r\n";
    	$data_string .= '        "isWritable": true,'."\r\n";
    	$data_string .= '        "isReadable": true,'."\r\n";
    	$data_string .= '        "datapointTypeValue": 0'."\r\n";
    	$data_string .= '        },'."\r\n";
    	$data_string .= '        "value": "'.$value.'",'."\r\n";
    	$data_string .= '        "dataType": 2,'."\r\n";
    	$data_string .= '        "datapointType": 0,'."\r\n";
    	$data_string .= '        "datapointStatus": 0'."\r\n";
    	rest_Viess($url,$ch,$username,$password,$data_string);    
}
	curl_close($ch);
//    $open =  "/var/www/html/plugins/script/core/ressources/Viessmann.log";
//    $output = date("d/m/Y H:i:s")." Run ViessmannU.php GT=".$gateway." CT=".$controller." DG=".$dataPGroup." HC=".$heatCircuit." DP=".$dataPId." US=".$username." PW= ******* TP=".$type." VL=".$value." Path=".getcwd()."\n";
//    $fp = fopen($open, "a+");
//    fwrite($fp, $output);
//    fclose($fp);


?>
